# Copyright 2006, Rick Wilson, modified by Matt666

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

# Name :          groupByLayer.rb 1.0
# Description :   Explodes groups/components, regroups all model entities by layer.
# Author :        Rick Wilson
# Usage :         1. Install into the plugins directory or into the 
#                    Plugins/examples directory and manually load from the ruby console "load 'examples/groupByLayer.rb'" 
#                 2. Run "Group by layer" from the Plugins menu.
# Date :          2006-10-18
# Type :          Tool
# History:        1.1 (2008-08-28) - Second version (matt666)

require 'sketchup.rb'
def layer_groups
	#Boucle de vrification des composants et groupes
	def layer_groups_bomb(ss)
		ss.each do |e|
			if e.respond_to? "explode"
				ents = e.explode
				ents.each{|ent|$l.push ent if ent.is_a?(Sketchup::Drawingelement)}
				layer_groups_bomb(ents)
			end
		end
	end
	
	# Programme principal
	model=Sketchup.active_model
	$l=[]
	sel=model.selection
	model.start_operation "Group by layers"
	Sketchup.set_status_text("Please wait, program is exploding all components and groups...")
	if sel.empty?
		model.active_entities.each{|ents|sel.add ents}
	end
	sel.each do |ent|
			$l.push ent
	end
	cn = 1
	puts "\nStep one : Exploding all components and groups..."
	while cn > 0
		layer_groups_bomb(sel)
		cn = 0
		for e in sel
			if ["ComponentInstance","Group"].index(e.typename)
				cn+=1
			end
		end
	end

	#Rcuprer le nom des calques
	puts "Step two : Layer names..."
	layerNames=[]
	model.layers.each{|l|layerNames<<l.name}

	#Grouper par calques
	puts "Step three : Group by layer..."
	$l = $l.uniq.delete_if{|e|e.deleted?}
	for m in layerNames
		sel.clear
		$l.each{|ee|puts ee if ee.parent != model;sel.add(ee) if ee.layer.name == m}
		puts " - Nombre d'lements dans le calque '" + m + "' : " + sel.count.to_s
		################################ THE UUUGLY LINE....
		model.active_entities.add_group(sel)
		################################
	end
	sel.clear
	puts "End of the program..."
	Sketchup.set_status_text("Done!")
	model.commit_operation
end

if( not file_loaded?("GroupByLayer.rb") )
	print "\n> Program 'GroupByLayer' loaded.\n  Menu plugins.\n  Type 'layer_groups' to run..."
    add_separator_to_menu("Plugins")
	if $submenu!=nil
		$submenu.add_item("Group by layer") { layer_groups }
	else
		UI.menu("Plugins").add_item("Group by layer") { layer_groups }
	end
end
file_loaded("groupByLayer.rb")
